check Top(*) < Top(*);
check Int < Top(*);
check Top(*) < Int;

check {|a:Int, b:String|} < {|b:String|};
check {|a:Int, b:String|} < {|a:Bool, b:String|};
check {|a:Int, b:String|} < {|a:Int, c:String|};
check {|a:Int, b:String|} < {|a:Int, b:Top(*)|};

Pos < Int;     % (Declare a new type variable Pos with bound Int)
check Pos < Int;
check Int < Pos;
check Int->Pos < Int->Int;
check Int->Int < Pos->Pos;
check Int->Pos < Pos->Int;
check Pos->Int < Int->Pos;

check All(A)A->A < Int->Int;
check All(B)B->Pos < All(A)A->Int;
check All(A<Int)A->A < All(A<Pos)A->Pos;
check Some(A<Pos) {|x:A, y:A->Pos|}  <  Some(B<Int) {|x:Int, y:B->Pos|};
check Some(A<Int) {|x:A, y:A->A|}  <  Some(A<Int) {|x:Int, y:A->Pos|};

check (Fun(A:*) A->A) Pos  <  Pos->Int;
check (Fun(A:*) A->A) Pos  <  (Fun(B:*) Pos->B) Int;

check Fun(A:*) Pos->A  <  Top(*->*);
check Fun(A:*) {|x:A, y:A->A|}  <  Fun(A:*) {|y:A->A|};
check Fun(A:*) All(B<A) A->A  <  Fun(A:*) All(B<Top(*)) B->A;

check All(M < Fun(A:*) {|x:A,y:Int|}) M(Pos)
    < All(M < Fun(A:*) {|x:A,y:Int|}) {|x:Int|};
check All(M < Fun(A:*) {|x:A,y:Int|}) M(Pos)  
    <  All(M < Fun(A:*) {|x:A,y:Int|}) M(Int);
check All(M < Fun(A:*) {|x:A,y:Int|}) M(Pos)  
    <  All(M < Fun(A:*) {|y:Int|}) M(Int);

check Top(*) < Top(*->*);

